
class Node {
    int value;
    Node next;
}

/*@

predicate node(Node no, Node ne)
	= no.value |-> ?v &*& no.next |-> ne;

@*/

/*@

predicate llist(LList l)
	= l.head |-> ?np &*& list(np);
	
predicate list(Node n)
	= n == null ? true
	            : node(n, ?ne) &*& list(ne);
	         
@*/

class LList {

    void reverse()
        //@ requires llist(this);
        //@ ensures llist(this);
    {
        Node previous = null;
        //@ open llist(this);
        Node next = this.head;
        Node temp = null;
        this.head = null;
        //@ close list(null);
        while (next != null)
            //@ invariant this.head |-> ?n &*& list(n) &*& list(next);
        {
            previous = this.head;
            this.head = next;
            temp = next;
            //@ open list(temp);
            //@ open node(temp, _);
            next = temp.next;
            temp.next = previous;
            //@ close node(temp, previous);
            //@ close list(temp);
        }
        //@ open list(next);
        //@ close llist(this);
    }   
    
    private Node head;
}